/**************************************
****  CONFIG.C  - Config Handling  ****
**************************************/

//-- Include Files -----------------------------------------------------------
#include <allegro.h>
#include <ctype.h>
#include "../cdrom/cdrom.h"
#include "../memory/memory.h"
#include "../input/input.h"

//-- Global Variables --------------------------------------------------------
int				config_vsync;
int				config_scanlines;
unsigned char	config_game_name[80];
int				controller1_up;
int				controller1_down;
int				controller1_left;
int				controller1_right;
int				controller1_a;
int				controller1_b;
int				controller1_c;
int				controller1_d;
int				controller1_start;
int				controller1_select;

int				controller2_up;
int				controller2_down;
int				controller2_left;
int				controller2_right;
int				controller2_a;
int				controller2_b;
int				controller2_c;
int				controller2_d;
int				controller2_start;
int				controller2_select;

//-- Imported Variables ------------------------------------------------------
extern char	*neogeo_prg_memory;

//-- Exported Functions ------------------------------------------------------
void	config_read(void);
void	config_read_name(void);

//----------------------------------------------------------------------------
void	config_read(void)
{
	int				temp;
	unsigned char	tmp[80];
	
	set_config_file("neocd.cfg");
	config_vsync = get_config_int(NULL, "vsync", 0);
	config_scanlines = get_config_int(NULL, "scanlines", 0);
	temp = get_config_int(NULL, "nationality", 0);
	if (temp>2)
		temp = 2;
	cpu_writemem24(0x10FD83, temp);
	cdrom_current_drive = get_config_int(NULL, "cdrom", -1);
	
	controller1_up = input_identify(get_config_string("keyboard1", "up", 
		"KEY_UP"));
	controller1_down = input_identify(get_config_string("keyboard1", "down", 
		"KEY_DOWN"));
	controller1_left = input_identify(get_config_string("keyboard1", "left", 
		"KEY_LEFT"));
	controller1_right = input_identify(get_config_string("keyboard1", "right", 
		"KEY_RIGHT"));
	controller1_a = input_identify(get_config_string("keyboard1", "a", 
		"KEY_A"));
	controller1_b = input_identify(get_config_string("keyboard1", "b", 
		"KEY_S"));
	controller1_c = input_identify(get_config_string("keyboard1", "c", 
		"KEY_D"));
	controller1_d = input_identify(get_config_string("keyboard1", "d", 
		"KEY_F"));
	controller1_start = input_identify(get_config_string("keyboard1", "start", 
		"KEY_1"));
	controller1_select = input_identify(get_config_string("keyboard1", 
		"select", "KEY_2"));

	controller2_up = input_identify(get_config_string("keyboard2", "up", 
		"KEY_U"));
	controller2_down = input_identify(get_config_string("keyboard2", "down", 
		"KEY_J"));
	controller2_left = input_identify(get_config_string("keyboard2", "left", 
		"KEY_H"));
	controller2_right = input_identify(get_config_string("keyboard2", "right", 
		"KEY_K"));
	controller2_a = input_identify(get_config_string("keyboard2", "a", 
		"KEY_6"));
	controller2_b = input_identify(get_config_string("keyboard2", "b", 
		"KEY_7"));
	controller2_c = input_identify(get_config_string("keyboard2", "c", 
		"KEY_8"));
	controller2_d = input_identify(get_config_string("keyboard2", "d", 
		"KEY_9"));
	controller2_start = input_identify(get_config_string("keyboard2", "start", 
		"KEY_3"));
	controller2_select = input_identify(get_config_string("keyboard2", 
		"select", "KEY_4"));
}

//----------------------------------------------------------------------------
void	config_read_name(void)
{
	unsigned char	*Ptr;
	int				temp;

	Ptr = neogeo_prg_memory + cpu_readmem24_dword(0x11A);
	swab(Ptr, config_game_name, 80);
	
	for(temp=0;temp<80;temp++)
		if (!isprint(config_game_name[temp]))
			config_game_name[temp]=0;
}

