/**************************************
**** SHELL.C -  Shell Command Line ****
**************************************/

//-- Include Files -----------------------------------------------------------
#include <allegro.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>

//-- Defines -----------------------------------------------------------------
#define	MAX_CMDS	20
#define MAX_MRU		10
#define MAX_ARGS	5
#define INSERT()	memmove(&shell_line[x+1], &shell_line[x], 78-x)
#define DELETE()	{ \
			if (x!=78)\
				memmove(&shell_line[x], &shell_line[x+1], 78-x);\
			else \
				shell_line[x] = 0; \
			}	
#define CHECK(a)	if (strcmp(cmd, shell_cmd_list[(a)])==0) \
			return (a)

//-- Enums -------------------------------------------------------------------
			
// Ne pas oublier de synchroniser avec celui de shell.h
enum	{
	SHELL_QUIT=0, SHELL_NEXT, SHELL_REGS, SHELL_STEP, SHELL_DUMP, SHELL_VDMP, SHELL_VSCR,
	SHELL_SMEM, SHELL_POKE, SHELL_RSET, SHELL_GO, SHELL_JAP, SHELL_US, SHELL_SPA, SHELL_MLST,
	SHELL_MLOD, SHELL_MAVL
	};

//-- Global Variables --------------------------------------------------------
const char	*shell_cmd_list[MAX_CMDS];
char		shell_mru[MAX_MRU][80];
int			shell_mru_line;
int			shell_mru_call_line;
char		shell_line[80];

int			shell_argc;
char		shell_argv[MAX_ARGS][80];

//-- Exported Functions ------------------------------------------------------
void	shell_init(void);
void	shell_get_cmd(void);

//----------------------------------------------------------------------------
void	shell_init(void)
{
	int	i;
	
	shell_cmd_list[SHELL_STEP] = "s";
	shell_cmd_list[SHELL_NEXT] = "n";
	shell_cmd_list[SHELL_REGS] = "r";
	shell_cmd_list[SHELL_QUIT] = "q";
	shell_cmd_list[SHELL_DUMP] = "d";
	shell_cmd_list[SHELL_VDMP] = "dv";
	shell_cmd_list[SHELL_VSCR] = "rs";
	shell_cmd_list[SHELL_SMEM] = "sb";
	shell_cmd_list[SHELL_POKE] = "p";
	shell_cmd_list[SHELL_RSET] = "reset";
	shell_cmd_list[SHELL_GO] = "g";
	shell_cmd_list[SHELL_JAP] = "jp";
	shell_cmd_list[SHELL_US] = "us";
	shell_cmd_list[SHELL_SPA] = "sp";
	shell_cmd_list[SHELL_MLST] = "ml";
	shell_cmd_list[SHELL_MLOD] = "mld";
	shell_cmd_list[SHELL_MAVL] = "ma";
	
	shell_mru_line = 0;
	for(i=0;i<MAX_MRU;i++)
		shell_mru[i][0] = 0;
}

//----------------------------------------------------------------------------
void	shell_get_cmd(void)
{
	short	touche;
	int		x, y, special;
	
	shell_mru_call_line = shell_mru_line;
	
	memset(shell_line, 0, 80);
	x = 0;
	y = wherey();
	
	do {
		if (x==78)
			gotoxy(x, y);
		else
			gotoxy(x+1, y);
			
		touche = readkey();
		
		switch( touche>>8 ) {
		case	KEY_LEFT :
			if (x>0)
				x--;
			break;
		case	KEY_UP :
			shell_mru_call_line--;
			if (shell_mru_call_line<0)
				shell_mru_call_line += MAX_MRU;
			printf("\r                                                                               \r");
			strcpy(shell_line, &shell_mru[shell_mru_call_line][0]);
			x = strlen(shell_line);
			break;				
		case	KEY_DOWN :
			shell_mru_call_line++;
			if (shell_mru_call_line>=MAX_MRU)
				shell_mru_call_line -= MAX_MRU;
			printf("\r                                                                               \r");
			strcpy(shell_line, &shell_mru[shell_mru_call_line][0]);
			x = strlen(shell_line);
			break;				
		case	KEY_RIGHT :
			if ((x<78)&&(shell_line[x]!=0))
				x++;
			break;
		case	KEY_BACKSPACE :
			if (x>0) {
				x--;
				DELETE();
			}
			break;
		case	KEY_DEL :
			DELETE();
			break;
			
		case	KEY_ENTER :
			break;
		
		default :
			if (x!=78) {
				INSERT();
				shell_line[x] = tolower(touche&0xFF);
				x++;
			}
		}
		
		gotoxy(1,y);
		if (x==78)
			printf("%s", shell_line);
		else {
			printf("%s", shell_line);
			printf(" ");
		}
		fflush(stdout);
		
		
	} while((touche&0xFF)!=0x0d);

	shell_argc = 0;
	y = 0;
	x = 0;

	printf("\r");

	if (strlen(shell_line)!=0)
		printf("\n");
		
	if (shell_line[0] == 0)
		return;
	
	strcpy(&shell_mru[shell_mru_line][0], shell_line);
	shell_mru_line = (shell_mru_line+1) % MAX_MRU;

	do {
		special = 0;
		while((shell_line[y] != ' ')&&(shell_line[y] != 0))
			shell_argv[x][special++]= shell_line[y++];
		
		shell_argv[x][special] = 0;
		shell_argc++;
		if (shell_line[y] != 0) {
			y++;
			x++;
		}
	} while((x<MAX_ARGS)&&(shell_line[y]!=0)) ;
}

//----------------------------------------------------------------------------
int	shell_identify_command(char *cmd)
{
	CHECK(SHELL_QUIT);
	CHECK(SHELL_NEXT);
	CHECK(SHELL_REGS);
	CHECK(SHELL_STEP);
	CHECK(SHELL_DUMP);
	CHECK(SHELL_VDMP);
	CHECK(SHELL_VSCR);
	CHECK(SHELL_SMEM);
	CHECK(SHELL_RSET);
	CHECK(SHELL_POKE);
	CHECK(SHELL_GO);
	CHECK(SHELL_JAP);
	CHECK(SHELL_US);
	CHECK(SHELL_SPA);
	CHECK(SHELL_MLST);
	CHECK(SHELL_MLOD);
	CHECK(SHELL_MAVL);
	return -1;
}

